#!/usr/bin/env python
from os import listdir
from os.path import isfile, join
import gzip
import re
import sys

# params
path ="./projects/iedera/sample_results"
p    = "0.04,0.96"
tag  = "t2"

# (1) get all output files
allfiles = [fname for fname in listdir(path) if isfile(join(path, fname))]
print "files:"+str(len(allfiles))


# (2) read the full content of each file and  merge equivalent n,w,l inputs (do this by w and n range, otherwise too much memory used !!)
for w_cons in range(18,26,2):
	for n_cons in range(1,5,1):
		print ("w:",str(w_cons)," n:",str(n_cons))
		content = []
		st = ""
		dic = {}
		# (2.1) read all files and store in a single dict the correct values
		for fname in allfiles:
		        try: # GZIP file
        		        with gzip.open(join(path,fname)) as f:
                		        content = f.readlines()
		        except IOError: # ASCII file
        		        with open(join(path,fname)) as f:
                		        content = f.readlines()

			for line in content:
				# get weight span length
				mo = re.match(r'^: .*\-n[ ][ ]*([0-9][0-9]*)[ ].*\-w[ ]*([0-9][0-9]*),[0-9][0-9]*[ ].*\-l[ ][ ]*([0-9][0-9]*)[ ].*$',line, re.M|re.I)
				if mo != None:
					n = mo.group(1)
					w = mo.group(2)
					l = mo.group(3)
					if int(w) == w_cons and int(n) == n_cons:
						sys.stdout.write('.')
						if (n,w,l) in dic:
							dic[(n,w,l)] += st
						else:
							dic[(n,w,l)] = st
					st = ""
				else:
					if re.match(r'^::.*$',line, re.M|re.I) == None:
						st += line
		# (2.2) write the merged infor a single file
		for n,w,l in dic:
			fname='input_merge_n'+str(n)+'_w'+str(w)+'_l'+str(l)+'_'+tag
			print fname
			with open(fname,'w') as f:
				f.write(dic[(n,w,l)])
				f.write("-spaced -BSymbols 01 -f " + p + " -b 0.5,0.5 -n " + str(n) + " -w " + str(w) + "," + str(w) + " -s " + str(w) + "," + str(s) +  " -l " + str(l) + " -p -r 1")
